#[derive(Copy, Clone, Default, PartialEq)]
pub struct PNext<P>(P);
#[derive(Copy, Clone, Default, PartialEq)]
pub struct P0;

pub type P1 = PNext<P0>;
pub type P2 = PNext<P1>;
pub type P3 = PNext<P2>;
pub type P4 = PNext<P3>;
pub type P5 = PNext<P4>;
pub type P6 = PNext<P5>;
pub type P7 = PNext<P6>;

pub trait Peano: Copy + Clone + Default + PartialEq {
    type Next: PeanoNonZero;
    type PrevOrZero: Peano;
    /// always set to ()
    /// this exists to allow Peano numbers to be used as struct parameters without PhantomData
    type Unit: Copy + Clone + Default + PartialEq;
    const VALUE: u32;
}

pub trait PeanoNonZero: Peano {
    type Prev: Peano;
}

impl Peano for P0 {
    type Next = P1;
    type PrevOrZero = P0;
    type Unit = ();
    const VALUE: u32 = 0;
}
impl<P: Peano> Peano for PNext<P> {
    type Next = PNext<PNext<P>>;
    type PrevOrZero = P;
    type Unit = ();
    const VALUE: u32 = 1 + P::VALUE;
}
impl<P: Peano> PeanoNonZero for PNext<P> {
    type Prev = P;
}

// A: LessThan<B> is satisfied only if A is strictly less than B.
pub trait LessThan<P: Peano> { }
impl<P: Peano> LessThan<PNext<P>> for P { }

